; BAO GRAPHICS LANGUAGE MACROS
; MR 5/8/92

BGL	macro
	dw	76h
	endm

BGL_EVEN	macro
	db	76h
	EVEN
	endm

EOF	macro
	dw	00h
	endm

LOGOL	macro
	dw	01h
	endm

NOOP	macro
	dw	02h
	endm


DEBUG	macro
	dw	04h
	endm


SURFACE	macro
	dw	05h
	endm


SPNT	macro	xx,yy,zz
	dw	06h
	dw	xx
	dw	yy
	dw	zz
	endm


CPNT	macro	xx,yy,zz
	dw	07h
	dw	xx
	dw	yy
	dw	zz
	endm


CLOSURE	macro
	dw	08h
	endm


GSURF	macro
	dw	09h
	endm


GSPNT	macro	ii,xx,yy,zz
	dw	0ah
	dw	ii
	dw	xx
	dw	yy
	dw	zz
	endm


GCPNT	macro	ii,xx,yy,zz
	dw	0bh
	dw	ii
	dw	xx
	dw	yy
	dw	zz
	endm


GCLOSURE	macro
	dw	0ch
	endm

;
; ERRS16  generate a error if the passed offset
; cant fit in a signed 16bit WORD
;
ERRS16	macro	x
	.errnz	(((x) + 32768) AND 0FFFF0000h)
	endm

JUMP	macro	dest
	local	start
start  label word
	dw	0dh
	dw	(offset dest)-(offset start)
	ERRS16	(offset dest)-(offset start)
	endm


SETCOLOR	macro	color
	dw	14h
	dw	color
	endm


GDEFRES	macro	n,i,x,y,z
	dw	11h,n,i,x,y,z
	endm


GSTRRES	macro	n
	dw	12h,n
	endm


GCNTRES	macro	n
	dw	13h,n
	endm


DEFRES	macro	n,x,y,z
	dw	0eh,n,x,y,z
	endm


STRRES	macro	n
	dw	0fh,n
	endm


CNTRES	macro	n
	dw	10h,n
	endm


TEXTURE	macro	n,ix,iy,iz,name
	dw	18h
	if	n eq 1
		dw	0C000h
	else
		if	n eq 2
			dw	08000h
		else
			if	n eq 3
				dw	04000h
			else
				dw	0
			endif
		endif
	endif
	dw	ix,iy,iz
	db	name,0,0
	endm


TEXTURE_REPEAT	macro	ix,iy,iz
	dw	05Dh
	dw	ix,iy,iz
	endm


TEXTURE_ROTATE	macro	pitch,bank,heading
	dw	05Eh
	dw	[(pitch/90)*256] + [(bank/90)*16] + [heading/90]
	endm


TEXTURE_ENABLE	macro	parm
	dw	017h,parm
	endm


PALETTE	macro	name
	dw	19h
	db	name,0,0
	endm


RESLIST	macro	start,number
	dw	1ah
	dw	start,number
	endm


VERTEX	macro	x,y,z
	dw	x,y,z
	endm

RESROW	macro	start,number,xs,ys,zs,xe,ye,ze
	dw	031h
	dw	start,number
	dw	xs,ys,zs
	dw	xe,ye,ze
	endm

FACE3	macro	px,py,pz,nx,ny,nz,p1,p2,p3
	dw	1dh,3
	dw	px,py,pz,nx,ny,nz
	dw	p1,p2,p3
	endm


FACE4	macro	px,py,pz,nx,ny,nz,p1,p2,p3,p4
	dw	1dh,4
	dw	px,py,pz,nx,ny,nz
	dw	p1,p2,p3,p4
	endm


FACE5	macro	px,py,pz,nx,ny,nz,p1,p2,p3,p4,p5
	dw	1dh,5
	dw	px,py,pz,nx,ny,nz
	dw	p1,p2,p3,p4,p5
	endm


FACE6	macro	px,py,pz,nx,ny,nz,p1,p2,p3,p4,p5,p6
	dw	1dh,6
	dw	px,py,pz,nx,ny,nz
	dw	p1,p2,p3,p4,p5,p6
	endm

FACE7	macro	px,py,pz,nx,ny,nz,p1,p2,p3,p4,p5,p6,p7
	dw	1dh,7
	dw	px,py,pz,nx,ny,nz
	dw	p1,p2,p3,p4,p5,p6,p7
	endm

FACE8	macro	px,py,pz,nx,ny,nz,p1,p2,p3,p4,p5,p6,p7,p8
	dw	1dh,8
	dw	px,py,pz,nx,ny,nz
	dw	p1,p2,p3,p4,p5,p6,p7,p8
	endm

FACE	macro	px,py,pz,nx,ny,nz,p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15,p16,p17,p18,p19,p20,p21,p22,p23,p24,p25,p26,p27,p28,p29,p30,p31,p32
	local	lb1,lb2
	dw	01Dh
	dw	[(lb2-lb1)/2]
	dw	px,py,pz,nx,ny,nz
lb1	dw	p1,p2,p3
	ifnb	<p4>
	dw	p4
	endif
	ifnb	<p5>
	dw	p5
	endif
	ifnb	<p6>
	dw	p6
	endif
	ifnb	<p7>
	dw	p7
	endif
	ifnb	<p8>
	dw	p8
	endif
	ifnb	<p9>
	dw	p9
	endif
	ifnb	<p10>
	dw	p10
	endif
	ifnb	<p11>
	dw	p11
	endif
	ifnb	<p12>
	dw	p12
	endif
	ifnb	<p13>
	dw	p13
	endif
	ifnb	<p14>
	dw	p14
	endif
	ifnb	<p15>
	dw	p15
	endif
	ifnb	<p16>
	dw	p16
	endif
	ifnb	<p17>
	dw	p17
	endif
	ifnb	<p18>
	dw	p18
	endif
	ifnb	<p19>
	dw	p19
	endif
	ifnb	<p20>
	dw	p20
	endif
	ifnb	<p21>
	dw	p21
	endif
	ifnb	<p22>
	dw	p22
	endif
	ifnb	<p23>
	dw	p23
	endif
	ifnb	<p24>
	dw	p24
	endif
	ifnb	<p25>
	dw	p25
	endif
	ifnb	<p26>
	dw	p26
	endif
	ifnb	<p27>
	dw	p27
	endif
	ifnb	<p28>
	dw	p28
	endif
	ifnb	<p29>
	dw	p29
	endif
	ifnb	<p30>
	dw	p30
	endif
	ifnb	<p31>
	dw	p31
	endif
	ifnb	<p32>
	dw	p32
	endif
lb2	label word
	endm



BGL_DEBUG	macro
__debug_	= $
	dw	04h
	NOOP
	endm


BGL_DEBUG_END	macro
	retf
	EVEN
__debug_end_	= $
	org	__debug_
	dw	016h
	dw	(__debug_end_ -__debug_)
	org	__debug_end_
	endm


HAZE	macro	val
	dw	1eh,val
	endm

HORIZON	macro	val
	dw	1fh,val
	endm

FACET3_TMAP	macro	a,b,c,d,p1,t1x,t1z,p2,t2x,t2z,p3,t3x,t3z
	dw	20h,3
	dw	a,b,c
	dd	d
	dw	p1,t1x,t1z
	dw	p2,t2x,t2z
	dw	p3,t3x,t3z
	endm

FACET4_TMAP	macro	a,b,c,d,p1,t1x,t1z,p2,t2x,t2z,p3,t3x,t3z,p4,t4x,t4z
	dw	20h,4
	dw	a,b,c
	dd	d
	dw	p1,t1x,t1z
	dw	p2,t2x,t2z
	dw	p3,t3x,t3z
	dw	p4,t4x,t4z
	endm

SUPERMESH	macro	x_grid,z_grid,x_patch,z_patch,x_disp,z_disp,x_view,z_view
	local	start
	dw	21h,x_grid,z_grid,x_patch,z_patch,x_disp,z_disp,x_view,z_view
start  label word
supermeshloc	= offset start
	endm	

SMROUTINE	macro	dest
	dw	(offset dest)-(supermeshloc)
	ERRS16	(offset dest)-(supermeshloc)
	endm

BGL_CALL	macro	routine
	local	start
start  label word
	dw	23h
	dw	(offset routine)-(offset start)
	ERRS16	(offset routine)-(offset start)
	endm

BGL_CALL_32	macro	routine
	local	start
start  label word
	dw	08Ah
	dd	(offset routine)-(offset start)
	endm

BGL_FAR_CALL	macro	routine,segment
	dw	05Ch
	dw	routine
	dw	segment
	endm


BGL_LIBRARY_CALL	macro	id0,id4,id8,id12	; calls a BGL library
	dw	063h			;opcode
	dd	id0
	dd	id4
	dd	id8
	dd	id12
	endm


BGL_RETURN	macro
	dw	22h
	endm

IFIN1	macro	dest,v,low,high
	local	start
start  label word
	dw	24h
	dw	(offset dest)-(offset start)
	dw	v,low,high
	ERRS16	(offset dest)-(offset start)
	endm


IFIN2	macro	dest,v1,low1,high1,v2,low2,high2
	local	start
start  label word
	dw	1Ch
	dw	(offset dest)-(offset start)
	dw	v1,low1,high1
	dw	v2,low2,high2
	ERRS16	(offset dest)-(offset start)
	endm


IFIN3	macro	dest,v1,low1,high1,v2,low2,high2,v3,low3,high3
	local	start
start  label word
	dw	21h
	dw	(offset dest)-(offset start)
	dw	v1,low1,high1
	dw	v2,low2,high2
	dw	v3,low3,high3
	ERRS16	(offset dest)-(offset start)
	endm


IFINBOXP	macro	dest,lowx,highx,lowy,highy,lowz,highz
	local	start
start  label word
	dw	73h
	dw	(offset dest)-(offset start)
	dw	lowx,highx
	dw	lowy,highy
	dw	lowz,highz
	ERRS16	(offset dest)-(offset start)
	endm


IFIN_BOX_PLANE	macro	dest,centerdx,centerdy,centerdz,sizex,sizey,sizez,pitch,bank,heading
	local	start
start  label word
	dw	1Bh
	dw	(offset dest)-(offset start)
	dw	centerdx,centerdy,centerdz		; box center offset from the scale command
	dw	sizex,sizey,sizez			; rotated size of the box
	dw	pitch,bank,heading			; box rotation
	ERRS16	(offset dest)-(offset start)
	endm



SEPARATION_PLANE	macro	dest,a,b,c,d
	local	start
start  label word
	dw	25h
	dw	(offset dest)-(offset start)
	dw	a,b,c
	dd	d
	ERRS16	(offset dest)-(offset start)
	endm

SIDE	macro	xv,low,high,r1,r2
	local	jump1
	IFIN1	xv,low,high,jump1
	BGL_CALL r1
	BGL_CALL r2
	BGL_RETURN
jump1  label word
	BGL_CALL r2
	BGL_CALL r1	
	BGL_RETURN
	endm

IFSIDE	macro	a,b,c,d,r1,r2
	local	jump1
	SEPARATION_PLANE jump1,a,b,c,d
	BGL_CALL r1
	BGL_CALL r2
	BGL_RETURN
jump1  label word
	BGL_CALL r2
	BGL_CALL r1	
	BGL_RETURN
	endm

IFSIDE_32	macro	a,b,c,d,r1,r2
	local	jump1
	SEPARATION_PLANE jump1,a,b,c,d
	BGL_CALL_32 r1
	BGL_CALL_32 r2
	BGL_RETURN
jump1  label word
	BGL_CALL_32 r2
	BGL_CALL_32 r1	
	BGL_RETURN
	endm

SETWRD	macro	v,n
	dw	26h,v,n
	endm

BGL_TEXTURED_FACET3	macro a,b,c,d,p1,p2,p3
	dw	27h,3
	dw	a,b,c
	dd	d
	dw	p1,p2,p3
	endm

BGL_TEXTURED_FACET4	macro a,b,c,d,p1,p2,p3,p4
	dw	27h,4
	dw	a,b,c
	dd	d
	dw	p1,p2,p3,p4
	endm


GRESLIST	macro	start,number
	dw	29h
	dw	start,number
	endm

GVERTEX	macro	x,y,z,nx,ny,nz
	dw	x,y,z,nx,ny,nz
	endm

GFACET3	macro	a,b,c,d,p1,p2,p3
	dw	2ah,3
	dw	a,b,c
	dd	d
	dw	p1,p2,p3
	endm

GFACET4	macro	a,b,c,d,p1,p2,p3,p4
	dw	2ah,4
	dw	a,b,c
	dd	d
	dw	p1,p2,p3,p4
	endm

GFACET5	macro	a,b,c,d,p1,p2,p3,p4,p5
	dw	2ah,5
	dw	a,b,c
	dd	d
	dw	p1,p2,p3,p4,p5
	endm

GFACET6	macro	a,b,c,d,p1,p2,p3,p4,p5,p6
	dw	2ah,6
	dw	a,b,c
	dd	d
	dw	p1,p2,p3,p4,p5,p6
	endm

GFACET7	macro	a,b,c,d,p1,p2,p3,p4,p5,p6,p7
	dw	2ah,7
	dw	a,b,c
	dd	d
	dw	p1,p2,p3,p4,p5,p6,p7
	endm

GFACET8	macro	a,b,c,d,p1,p2,p3,p4,p5,p6,p7,p8
	dw	2ah,8
	dw	a,b,c
	dd	d
	dw	p1,p2,p3,p4,p5,p6,p7,p8
	endm


GFACET	macro	a,b,c,d,p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15,p16,p17,p18,p19,p20,p21,p22,p23,p24,p25,p26,p27,p28,p29,p30,p31,p32
	local	lb1,lb2
	dw	02Ah
	dw	[(lb2-lb1)/2]
	dw	a,b,c
	dd	d
lb1	dw	p1,p2,p3
	ifnb	<p4>
	dw	p4
	endif
	ifnb	<p5>
	dw	p5
	endif
	ifnb	<p6>
	dw	p6
	endif
	ifnb	<p7>
	dw	p7
	endif
	ifnb	<p8>
	dw	p8
	endif
	ifnb	<p9>
	dw	p9
	endif
	ifnb	<p10>
	dw	p10
	endif
	ifnb	<p11>
	dw	p11
	endif
	ifnb	<p12>
	dw	p12
	endif
	ifnb	<p13>
	dw	p13
	endif
	ifnb	<p14>
	dw	p14
	endif
	ifnb	<p15>
	dw	p15
	endif
	ifnb	<p16>
	dw	p16
	endif
	ifnb	<p17>
	dw	p17
	endif
	ifnb	<p18>
	dw	p18
	endif
	ifnb	<p19>
	dw	p19
	endif
	ifnb	<p20>
	dw	p20
	endif
	ifnb	<p21>
	dw	p21
	endif
	ifnb	<p22>
	dw	p22
	endif
	ifnb	<p23>
	dw	p23
	endif
	ifnb	<p24>
	dw	p24
	endif
	ifnb	<p25>
	dw	p25
	endif
	ifnb	<p26>
	dw	p26
	endif
	ifnb	<p27>
	dw	p27
	endif
	ifnb	<p28>
	dw	p28
	endif
	ifnb	<p29>
	dw	p29
	endif
	ifnb	<p30>
	dw	p30
	endif
	ifnb	<p31>
	dw	p31
	endif
	ifnb	<p32>
	dw	p32
	endif
lb2	label word
	endm



REJECT	macro	dest,x,y,z,radius
	local	start
start  label word
	dw	2ch
	dw	(offset dest)-(offset start)
	dw	x,y,z,radius
	ERRS16	(offset dest)-(offset start)
	endm

SCOLOR24	macro	r,g,b
	dw	2dh
	db	r,g,b,0
	endm

LCOLOR24	macro	r,g,b
	dw	2eh
	db	r,g,b,0
	endm

SET_BRIGHTNESS	macro	value
	dw	030h
	dw	value
	endm

ADDOBJ	macro	dest
	local	start
start  label word
	dw	32h
	dw	(offset dest)-(offset start)
	ERRS16	(offset dest)-(offset start)
	endm

ADDOBJ_32	macro	dest
	local	start
start  label word
	dw	02Bh
	dd	(offset dest)-(offset start)
	endm

INSTANCE_CALL	macro dest,p,b,hh
	local	start
start  label word
	dw	033h
	dw	(offset dest)-(offset start)
	dw	p
	dw	b
	dw	hh
	ERRS16	(offset dest)-(offset start)
	endm


CONCAVE	macro				; override the next polygon to be CONCAVE
	dw	038h
	endm

BALL	macro	size,x,y,z
	dw	028h
	dw	size
	dw	x,y,z
	endm


IFMSK	macro	dest,var,mask
	local	start
start  label word
	dw	039h
	dw	(offset dest)-(offset start)
	dw	offset var
	dw	mask
	ERRS16	(offset dest)-(offset start)
	endm

; CASE	var_addr,num_cases,case_fall,case_addresses...
;	if [var_address] < num_cases
;		jmp [CASE + 4 + [var_address]*2]
;	else fall through

CASE	macro	var_addr,case_fall,c0,c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,c20,c21,c22,c23,c24
	local	lbl
lbl	dw	003h
	dw	[(lb3-lb2)/2]
	dw	var_addr
	dw	case_fall-lbl
lb2	label word
	ifnb	<c0>
	dw	c0-lbl
	endif
	ifnb	<c1>
	dw	c1-lbl
	endif
	ifnb	<c2>
	dw	c2-lbl
	endif
	ifnb	<c3>
	dw	c3-lbl
	endif
	ifnb	<c4>
	dw	c4-lbl
	endif
	ifnb	<c5>
	dw	c5-lbl
	endif
	ifnb	<c6>
	dw	c6-lbl
	endif
	ifnb	<c7>
	dw	c7-lbl
	endif
	ifnb	<c8>
	dw	c8-lbl
	endif
	ifnb	<c9>
	dw	c9-lbl
	endif
	ifnb	<c10>
	dw	c10-lbl
	endif
	ifnb	<c11>
	dw	c11-lbl
	endif
	ifnb	<c12>
	dw	c12-lbl
	endif
	ifnb	<c13>
	dw	c13-lbl
	endif
	ifnb	<c14>
	dw	c14-lbl
	endif
	ifnb	<c15>
	dw	c15-lbl
	endif
	ifnb	<c16>
	dw	c16-lbl
	endif
	ifnb	<c17>
	dw	c17-lbl
	endif
	ifnb	<c18>
	dw	c18-lbl
	endif
	ifnb	<c19>
	dw	c19-lbl
	endif
	ifnb	<c20>
	dw	c20-lbl
	endif
	ifnb	<c21>
	dw	c21-lbl
	endif
	ifnb	<c22>
	dw	c22-lbl
	endif
	ifnb	<c23>
	dw	c23-lbl
	endif
	ifnb	<c24>
	dw	c24-lbl
	endif
lb3	label word
	endm


SCALE	macro	dest,signal,size,scale,lat,latf,lon,lonf,alt,altf
	local	start
start  label word
	dw	02fh
	dw	(offset dest)-(offset start)
	dw	signal
	dw	size
	dw	0			; radsort ptr
	dd	scale
	dw	latf
	dd	lat
	dw	lonf
	dd	lon
	dw	altf
	dd	alt
	ERRS16	(offset dest)-(offset start)
	endm


SUPER_SCALE	macro	dest,signal,size,scale
	local	start
start  label word
	dw	34h
	dw	(offset dest)-(offset start)
	dw	signal
	dw	size
	dw	scale
	ERRS16	(offset dest)-(offset start)
	endm


POSITION	macro	dest,signal,size,lat,latf,lon,lonf,alt,altf
	local	start
start  label word
	dw	03Ch
	dw	(offset dest)-(offset start)
	dw	signal
	dw	size
	dw	0			; radsort ptr
	dw	latf
	dd	lat
	dw	lonf
	dd	lon
	dw	altf
	dd	alt
	ERRS16	(offset dest)-(offset start)
	endm


VPOSITION	macro	dest,signal,size,adrs
	local	start
start  label word
	dw	3Ah
	dw	(offset dest)-(offset start)
	dw	signal
	dw	size
	dw	0			; radsort ptr
	dw	adrs
	ERRS16	(offset dest)-(offset start)
	endm


VSCALE	macro	dest,signal,size,scale,var
	local	start
start  label word
	dw	04ch
	dw	(offset dest)-(offset start)
	dw	signal
	dw	size
	dw	0			; radsort ptr
	dd	scale
	dw	var
	ERRS16	(offset dest)-(offset start)
	endm


VINSTANCE_CALL	macro	dest,var
	local	start
start  label word
	dw	03Bh
	dw	(offset dest)-(offset start)
	dw	offset var
	ERRS16	(offset dest)-(offset start)
	endm

SEED	macro	type,xsize,zsize,realalt,latgrid,longrid,number
	dw	3dh
	dd	type
	dd	xsize
	dd	zsize
	dd	realalt
	dw	latgrid
	dw	longrid
	dw	number
	endm

FACET3	macro	a,b,c,d,p1,p2,p3
	dw	3eh,3
	dw	a,b,c
	dd	d
	dw	p1,p2,p3
	endm

FACET4	macro	a,b,c,d,p1,p2,p3,p4
	dw	3eh,4
	dw	a,b,c
	dd	d
	dw	p1,p2,p3,p4
	endm

FACET5	macro	a,b,c,d,p1,p2,p3,p4,p5
	dw	3eh,5
	dw	a,b,c
	dd	d
	dw	p1,p2,p3,p4,p5
	endm

FACET6	macro	a,b,c,d,p1,p2,p3,p4,p5,p6
	dw	3eh,6
	dw	a,b,c
	dd	d
	dw	p1,p2,p3,p4,p5,p6
	endm

FACET7	macro	a,b,c,d,p1,p2,p3,p4,p5,p6,p7
	dw	3eh,7
	dw	a,b,c
	dd	d
	dw	p1,p2,p3,p4,p5,p6,p7
	endm

FACET8	macro	a,b,c,d,p1,p2,p3,p4,p5,p6,p7,p8
	dw	3eh,8
	dw	a,b,c
	dd	d
	dw	p1,p2,p3,p4,p5,p6,p7,p8
	endm

FACET12	macro	a,b,c,d,p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12
	dw	3eh,12
	dw	a,b,c
	dd	d
	dw	p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12
	endm

FACET16	macro	a,b,c,d,p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15,p16
	dw	3eh,16
	dw	a,b,c
	dd	d
	dw	p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15,p16
	endm

FACET	macro	a,b,c,d,p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15,p16,p17,p18,p19,p20,p21,p22,p23,p24,p25,p26,p27,p28,p29,p30,p31,p32,p33,p34,p35
	local	lb1,lb2
	dw	03Eh
	dw	[(lb2-lb1)/2]
	dw	a,b,c
	dd	d
lb1	dw	p1,p2,p3
	ifnb	<p4>
	dw	p4
	endif
	ifnb	<p5>
	dw	p5
	endif
	ifnb	<p6>
	dw	p6
	endif
	ifnb	<p7>
	dw	p7
	endif
	ifnb	<p8>
	dw	p8
	endif
	ifnb	<p9>
	dw	p9
	endif
	ifnb	<p10>
	dw	p10
	endif
	ifnb	<p11>
	dw	p11
	endif
	ifnb	<p12>
	dw	p12
	endif
	ifnb	<p13>
	dw	p13
	endif
	ifnb	<p14>
	dw	p14
	endif
	ifnb	<p15>
	dw	p15
	endif
	ifnb	<p16>
	dw	p16
	endif
	ifnb	<p17>
	dw	p17
	endif
	ifnb	<p18>
	dw	p18
	endif
	ifnb	<p19>
	dw	p19
	endif
	ifnb	<p20>
	dw	p20
	endif
	ifnb	<p21>
	dw	p21
	endif
	ifnb	<p22>
	dw	p22
	endif
	ifnb	<p23>
	dw	p23
	endif
	ifnb	<p24>
	dw	p24
	endif
	ifnb	<p25>
	dw	p25
	endif
	ifnb	<p26>
	dw	p26
	endif
	ifnb	<p27>
	dw	p27
	endif
	ifnb	<p28>
	dw	p28
	endif
	ifnb	<p29>
	dw	p29
	endif
	ifnb	<p30>
	dw	p30
	endif
	ifnb	<p31>
	dw	p31
	endif
	ifnb	<p32>
	dw	p32
	endif
	ifnb	<p33>
	dw	p33
	endif
	ifnb	<p34>
	dw	p34
	endif
	ifnb	<p35>
	dw	p35
	endif
lb2	label word
	endm

ALPHA macro acolor
	dw	08Fh
	dd	acolor
	endm

ALPHA_FACET macro	acolor,a,b,c,d,p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15,p16,p17,p18,p19,p20,p21,p22,p23,p24,p25,p26,p27,p28,p29,p30,p31,p32,p33,p34,p35
	ALPHA acolor
	FACET a,b,c,d,p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15,p16,p17,p18,p19,p20,p21,p22,p23,p24,p25,p26,p27,p28,p29,p30,p31,p32,p33,p34,p35
	ALPHA 0
	endm

SHADOW_CALL	macro	routine
	local	start
start  label word
	dw	3Fh
	dw	(offset routine)-(offset start)
	ERRS16	(offset routine)-(offset start)
	endm

SHADOW_VPOSITION	macro	adrs
	dw	40h
	dw	adrs
	endm

SHADOW_VICALL	macro	dest,var
	local	start
start  label word
	dw	041h
	dw	(offset dest)-(offset start)
	dw	offset var
	ERRS16	(offset dest)-(offset start)
	endm

POINT_VICALL	macro	dest,xx,yy,zz,pp,pv,bb,bv,hh,hv
	local	start
start  label word
	dw	046h
	dw	(offset dest)-(offset start)
	dw	xx,yy,zz
	dw	pp,pv,bb,bv,hh,hv
	ERRS16	(offset dest)-(offset start)
	endm

PNT	macro	x,y,z
	dw	037h
	dw	x,y,z
	endm

MAP_SCALE	macro	scale
	dw	47h
	dw	scale
	endm

VAR_SEG	macro	tseg
	dw	48h
	dw	tseg
	endm

BLDING	macro	n,c,dx,dy,dz,s,x,z
	dw	49h
	dw	n,c,dx,dy,dz,s,x,z
	endm

LANDING_LIGHTS_VICALL	macro	dest,var,lx,ly,lz
	local	start
start  label word
	dw	04ah
	dw	(offset dest)-(offset start)
	dw	offset var
	dw	lx
	dw	ly
	dw	lz
	ERRS16	(offset dest)-(offset start)
	endm

BGL_OVERLAY	macro	id,c0,c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,c20,c21,c22,c23,c24
	local	lbl,lbl2
lbl	dw	4Bh
	dw	(lbl2-lbl)
	dw	id
	ifnb	<c0>
	dw	c0
	endif
	ifnb	<c1>
	dw	c1
	endif
	ifnb	<c2>
	dw	c2
	endif
	ifnb	<c3>
	dw	c3
	endif
	ifnb	<c4>
	dw	c4
	endif
	ifnb	<c5>
	dw	c5
	endif
	ifnb	<c6>
	dw	c6
	endif
	ifnb	<c7>
	dw	c7
	endif
	ifnb	<c8>
	dw	c8
	endif
	ifnb	<c9>
	dw	c9
	endif
	ifnb	<c10>
	dw	c10
	endif
	ifnb	<c11>
	dw	c11
	endif
	ifnb	<c12>
	dw	c12
	endif
	ifnb	<c13>
	dw	c13
	endif
	ifnb	<c14>
	dw	c14
	endif
	ifnb	<c15>
	dw	c15
	endif
	ifnb	<c16>
	dw	c16
	endif
	ifnb	<c17>
	dw	c17
	endif
	ifnb	<c18>
	dw	c18
	endif
	ifnb	<c19>
	dw	c19
	endif
	ifnb	<c20>
	dw	c20
	endif
	ifnb	<c21>
	dw	c21
	endif
	ifnb	<c22>
	dw	c22
	endif
	ifnb	<c23>
	dw	c23
	endif
	ifnb	<c24>
	dw	c24
	endif
lbl2	label word
	endm


VAR2LOW64K	macro	d,s
	dw	04dh
	dw	d,s
	endm


LOW64K2VAR	macro	d,s
	dw	04eh
	dw	d,s
	endm


MOVWRD	macro	d,s
	dw	04fh
	dw	d,s
	endm


GCOLOR	macro	color
	dw	50h
	dw	color
	endm



LCOLOR	macro	color
	dw	51h
	dw	color
	endm


SCOLOR	macro	color
	dw	52h
	dw	color
	endm


GCOLOR_ABS	macro	color
	dw	53h
	dw	color
	endm


ASMCALL_32	macro	asm_offset
	dw	08Ch
	dd	offset asm_offset
	endm

SET_SURFACE_TYPE	macro	t,x,z,alt
	dw	055h
	dw	t,x,z,alt
	endm

SET_WEATHER	macro	skip
	local	start
start  label word
	dw	056h
	dw	(offset skip)-(offset start)
	ERRS16	(offset skip)-(offset start)
	endm

WEATHER	macro	type,angle,factor,extra
	dw	057h
	dw	04ch+type*256
	dw	angle
	dw	factor
	dw	extra
	endm

TEXTURE_BOUNDS	macro	lx,lz,ux,uz
	dw	058h
	dd	lx,lz,ux,uz
	endm

VAR_SEG_ID	macro
	dw	059h
	endm

SEED_ADDOBJ	macro	dest
	local	start
start  label word
	dw	5Ah
	dw	(offset dest)-(offset start)
	ERRS16	(offset dest)-(offset start)
	endm

INDIRECT_CALL	macro	var
	dw	5bh
	dw	var
	endm

IFSIZEV	macro	dest,radius,pixels
	local	start
start  label word
	dw	5Fh
	dw	(offset dest)-(offset start)
	dw	radius,pixels
	ERRS16	(offset dest)-(offset start)
	endm



FACE3_TMAP	macro	px,py,pz,nx,ny,nz,p1,t1x,t1z,p2,t2x,t2z,p3,t3x,t3z
	dw	60h,3
	dw	px,py,pz,nx,ny,nz
	dw	p1,t1x,t1z
	dw	p2,t2x,t2z
	dw	p3,t3x,t3z
	endm

FACE4_TMAP	macro	px,py,pz,nx,ny,nz,p1,t1x,t1z,p2,t2x,t2z,p3,t3x,t3z,p4,t4x,t4z
	dw	60h,4
	dw	px,py,pz,nx,ny,nz
	dw	p1,t1x,t1z
	dw	p2,t2x,t2z
	dw	p3,t3x,t3z
	dw	p4,t4x,t4z
	endm

FACE7_TMAP	macro	px,py,pz,nx,ny,nz,p1,t1x,t1z,p2,t2x,t2z,p3,t3x,t3z,p4,t4x,t4z,p5,t5x,t5z,p6,t6x,t6z,p7,t7x,t7z
	dw	60h,7
	dw	px,py,pz,nx,ny,nz
	dw	p1,t1x,t1z
	dw	p2,t2x,t2z
	dw	p3,t3x,t3z
	dw	p4,t4x,t4z
	dw	p5,t5x,t5z
	dw	p6,t6x,t6z
	dw	p7,t7x,t7z
	endm



RESLIST_SCALE	macro	start,cnt
	dw	61h
	dw	start,cnt
	endm



IFVIS4	macro	dest,p1,p2,p3,p4
	local	start
start  label word
	dw	62h
	dw	(offset dest)-(offset start)
	dw	4
	dw	p1,p2,p3,p4
	ERRS16	(offset dest)-(offset start)
	endm

IFVIS8	macro	dest,p1,p2,p3,p4,p5,p6,p7,p8
	local	start
start  label word
	dw	62h
	dw	(offset dest)-(offset start)
	dw	8
	dw	p1,p2,p3,p4,p5,p6,p7,p8
	ERRS16	(offset dest)-(offset start)
	endm

IFGT	macro	dest,var,num
	IFIN1	dest,var,num,32767
	endm

IFLT	macro	dest,var,num
	IFIN1	dest,var,-32768,num
	endm

IFEQ	macro	dest,var,num
	IFIN1	dest,var,num,num
	endm

PNTROW	macro	x1,y1,z1,x2,y2,z2,n
	dw	35h
	dw	x1,y1,z1,x2,y2,z2,n
	endm


TEXTURE_RUNWAY	macro	lat,latf,lon,lonf,alt,altf,length,width,heading,flags,ident,surface
	dw	044h
	dw	latf
	dd	lat
	dw	lonf
	dd	lon
	dw	altf
	dd	alt
	dw	heading
	dw	length
	dw	width
	db	flags
	db	ident
	db	0,0
	db	surface
	db	0		; rw_threshold_flags	
	dw	0		; rw_threshold_south1	
	dw	0		; rw_threshold_south2	
	dw	0		; rw_threshold_north1	
	dw	0		; rw_threshold_north2	
	db	0		; rw_s_light_flags	
	db	0		; rw_s_light_system	
	db	0		; rw_s_light_strobes	
	db	0		; rw_s_light_vasi_type	
	dw	0		; rw_s_light_vasi_angle	
	dw	0		; rw_s_light_vasi_x	
	dw	0		; rw_s_light_vasi_z	
	dw	0		; rw_s_light_vasi_space	
	db	0		; rw_n_light_flags	
	db	0		; rw_n_light_system	
	db	0		; rw_n_light_strobes	
	db	0		; rw_n_light_vasi_type	
	dw	0		; rw_n_light_vasi_angle	
	dw	0		; rw_n_light_vasi_x	
	dw	0		; rw_n_light_vasi_z	
	dw	0		; rw_n_light_vasi_space	
	endm


RUNWAY_MAIN	macro	lat,latf,lon,lonf,alt,altf,length,width,heading,flags,ident,lights,surface
	dw	044h
	dw	latf		; \ runway center latitude (48-bit meters*65536)
	dd	lat		; /
	dw	lonf		; \ runway cneter longitude (48-bit pseudodegrees)
	dd	lon		; /
	dw	altf		; \ runway alitude (feet MSL) (48-bit meters*65536)
	dd	alt		; /
	dw	heading		; runway true heading (16-bit pseudodegrees)
	dw	length		; runway length (feet)
	dw	width		; runway width (feet)
	db	flags		;
	db	ident		;
	db	lights		; edge lights, center lights
	db	0		; reserved for expansion
	db	surface		;
	endm

RUNWAY_THRESHOLD macro	flags,s_thr_ofs,s_blast_pad,n_thr_ofs,n_blast_pad
	db	flags		; threshold_flags	
	dw	s_thr_ofs	; south threshold offset (feet)
	dw	s_blast_pad	; south blast pad size (feet)
	dw	n_thr_ofs	; north threshold offset (feet)
	dw	n_blast_pad	; north blast pas size (feet)
	endm

RUNWAY_LIGHTS	macro	flags,approach_type,strobes,vasi_type,vasi_angle,vasi_x,vasi_z,vasi_space
	db	flags		; light flags	
	db	approach_type	; approach system type
	db	strobes		; number of strobes
	db	vasi_type	; VASI type
	dw	vasi_angle	; VASI angle (16-bit pseudodegrees)
	dw	vasi_x		; VASI X offset (feet)
	dw	vasi_z		; VASI Z offset (feet)
	dw	vasi_space	; VASI spacing between bars (feet)
	endm


POLYGON_RUNWAY	macro	lat,latf,lon,lonf,alt,altf,length,width,heading,flags,ident,surface
	dw	044h
	dw	latf
	dd	lat
	dw	lonf
	dd	lon
	dw	altf
	dd	alt
	dw	heading
	dw	length
	dw	width
	db	flags
	db	ident
	db	0,0
	db	surface
	db	0		; rw_threshold_flags	
	dw	0		; rw_threshold_south1	
	dw	0		; rw_threshold_south2	
	dw	0		; rw_threshold_north1	
	dw	0		; rw_threshold_north2	
	db	0		; rw_s_light_flags	
	db	0		; rw_s_light_system	
	db	0		; rw_s_light_strobes	
	db	0		; rw_s_light_vasi_type	
	dw	0		; rw_s_light_vasi_angle	
	dw	0		; rw_s_light_vasi_x	
	dw	0		; rw_s_light_vasi_z	
	dw	0		; rw_s_light_vasi_space	
	db	0		; rw_n_light_flags	
	db	0		; rw_n_light_system	
	db	0		; rw_n_light_strobes	
	db	0		; rw_n_light_vasi_type	
	dw	0		; rw_n_light_vasi_angle	
	dw	0		; rw_n_light_vasi_x	
	dw	0		; rw_n_light_vasi_z	
	dw	0		; rw_n_light_vasi_space	
	endm

APPROACH_LIGHTS	macro	delta_z,width,heading,flags,system,strobes,vasi,vasi_angle,vasi_dx,vasi_dz,vasi_space
	dw	072h
	dw	heading
	dw	width
	dw	delta_z
	db	flags
	db	system
	db	strobes
	db	vasi
	dw	vasi_angle
	dw	vasi_dx
	dw	vasi_dz
	dw	vasi_space
	endm


BGL_LIBRARY	macro	a,b,c,d
	dw	063h
	dw	d,c,b,a
	endm

SYNTH_BUILDINGS	macro	x,z,egx,egz,et,eh,ex,ez
	dw	64h
	dw	x,z
	dw	egx,egz,et,eh,ex,ez
	endm

VSCOLOR	macro	var
	dw	65h
	dw	var
	endm

VGCOLOR	macro	var
	dw	66h
	dw	var
	endm

VLCOLOR	macro	var
	dw	67h
	dw	var
	endm

TMAP_LIGHT_SHADE	macro	nx,ny,nz
	dw	68h,nx,ny,nz
	endm

ROAD_START	macro	width,x,y,z
	dw	69h
	dw	width
	dw	x,y,z
	endm

ROAD_CONT	macro	x,y,z
	dw	6ah
	dw	x,y,z
	endm

RIVER_START	macro	width,x,y,z
	dw	6bh
	dw	width
	dw	x,y,z
	endm

RIVER_CONT	macro	x,y,z
	dw	6ch
	dw	x,y,z
	endm


IFSIZEH	macro	dest,radius,pixels
	local	start
start  label word
	dw	6Dh
	dw	(offset dest)-(offset start)
	dw	radius,pixels
	ERRS16	(offset dest)-(offset start)
	endm


TAXIWAY_START	macro	width,x,y,z
	dw	6eh
	dw	width
	dw	x,y,z
	endm

TAXIWAY_CONT	macro	x,y,z
	dw	6fh
	dw	x,y,z
	endm

;&AREA_SENSE4	macro	stype,x1,z1,x2,z2,x3,z3,x4,z4
;&	dw	70h,4,stype
;&	dw	x1,z1,x2,z2,x3,z3,x4,z4
;&	endm

AREA_SENSE4	macro	dest,x1,z1,x2,z2,x3,z3,x4,z4
	local	start
start  label word
	dw	70h
	dw	(offset dest)-(offset start)
	dw	4,x1,z1,x2,z2,x3,z3,x4,z4
	ERRS16	(offset dest)-(offset start)
	endm

AREA_SENSE5	macro	dest,x1,z1,x2,z2,x3,z3,x4,z4,x5,z5
	local	start
start  label word
	dw	70h
	dw	(offset dest)-(offset start)
	dw	5,x1,z1,x2,z2,x3,z3,x4,z4,x5,z5
	ERRS16	(offset dest)-(offset start)
	endm

AREA_SENSE6	macro	dest,x1,z1,x2,z2,x3,z3,x4,z4,x5,z5,x6,z6
	local	start
start  label word
	dw	70h
	dw	(offset dest)-(offset start)
	dw	6,x1,z1,x2,z2,x3,z3,x4,z4,x5,z5,x6,z6
	ERRS16	(offset dest)-(offset start)
	endm

ALTITUDE_SET	macro	alt
	dw	71h
	dw	alt
	endm

ADDCAT	macro	dest,cat
	local	start
start  label word
	dw	74h
	dw	(offset dest)-(offset start)
	dw	cat
	ERRS16	(offset dest)-(offset start)
	endm

ADDCAT_32	macro	dest,cat
	local	start
start  label word
	dw	08Bh
	dd	(offset dest)-(offset start)
	dw	cat
	endm

ELEVATION_MAP	macro	g_x, g_y, p_x, p_y, d_x, d_y, minalt, maxalt
	dw	15h
	dw	g_x, g_y, p_x, p_y, d_x, d_y, minalt, maxalt
	endm

ELEVATION_POINT macro x, z, alt
	db	x, z
	dw	alt
	endm

ADDMTN	macro	dest
	local	start
start  label word
	dw	75h
	dw	(offset dest)-(offset start)
	ERRS16	(offset dest)-(offset start)
	endm


SCALE_AGL	macro	dest,signal,size,scale,lat,latf,lon,lonf,alt,altf
	local	start
start  label word
	dw	077h
	dw	(offset dest)-(offset start)
	dw	signal
	dw	size
	dw	0			; radsort ptr
	dd	scale
	dw	latf
	dd	lat
	dw	lonf
	dd	lon
	dw	altf			; dummy altitude to be filled in by
	dd	alt			; command itself
	ERRS16	(offset dest)-(offset start)
	endm


ROAD_CONTW	macro	w,x,y,z
	dw	78h
	dw	w,x,y,z
	endm

RIVER_CONTW	macro	w,x,y,z
	dw	79h
	dw	w,x,y,z
	endm

GFACET3_TMAP	macro	a,b,c,d,p1,t1x,t1z,p2,t2x,t2z,p3,t3x,t3z
	dw	7Ah,3
	dw	a,b,c
	dd	d
	dw	p1,t1x,t1z
	dw	p2,t2x,t2z
	dw	p3,t3x,t3z
	endm

GFACET4_TMAP	macro	a,b,c,d,p1,t1x,t1z,p2,t2x,t2z,p3,t3x,t3z,p4,t4x,t4z
	dw	7Ah,4
	dw	a,b,c
	dd	d
	dw	p1,t1x,t1z
	dw	p2,t2x,t2z
	dw	p3,t3x,t3z
	dw	p4,t4x,t4z
	endm

GFACET5_TMAP	macro	a,b,c,d,p1,t1x,t1z,p2,t2x,t2z,p3,t3x,t3z,p4,t4x,t4z,p5,t5x,t5z
	dw	7Ah,5
	dw	a,b,c
	dd	d
	dw	p1,t1x,t1z
	dw	p2,t2x,t2z
	dw	p3,t3x,t3z
	dw	p4,t4x,t4z
	dw	p5,t5x,t5z
	endm

GFACET6_TMAP	macro	a,b,c,d,p1,t1x,t1z,p2,t2x,t2z,p3,t3x,t3z,p4,t4x,t4z,p5,t5x,t5z,p6,t6x,t6z
	dw	7Ah,6
	dw	a,b,c
	dd	d
	dw	p1,t1x,t1z
	dw	p2,t2x,t2z
	dw	p3,t3x,t3z
	dw	p4,t4x,t4z
	dw	p5,t5x,t5z
	dw	p6,t6x,t6z
	endm

GFACET7_TMAP	macro	a,b,c,d,p1,t1x,t1z,p2,t2x,t2z,p3,t3x,t3z,p4,t4x,t4z,p5,t5x,t5z,p6,t6x,t6z,p7,t7x,t7z
	dw	7Ah,7
	dw	a,b,c
	dd	d
	dw	p1,t1x,t1z
	dw	p2,t2x,t2z
	dw	p3,t3x,t3z
	dw	p4,t4x,t4z
	dw	p5,t5x,t5z
	dw	p6,t6x,t6z
	dw	p7,t7x,t7z
	endm

GFACET8_TMAP	macro	a,b,c,d,p1,t1x,t1z,p2,t2x,t2z,p3,t3x,t3z,p4,t4x,t4z,p5,t5x,t5z,p6,t6x,t6z,p7,t7x,t7z,p8,t8x,t8z
	dw	7Ah,8
	dw	a,b,c
	dd	d
	dw	p1,t1x,t1z
	dw	p2,t2x,t2z
	dw	p3,t3x,t3z
	dw	p4,t4x,t4z
	dw	p5,t5x,t5z
	dw	p6,t6x,t6z
	dw	p7,t7x,t7z
	dw	p8,t8x,t8z
	endm

GFACET9_TMAP	macro	a,b,c,d,p1,t1x,t1z,p2,t2x,t2z,p3,t3x,t3z,p4,t4x,t4z,p5,t5x,t5z,p6,t6x,t6z,p7,t7x,t7z,p8,t8x,t8z,p9,t9x,t9z
	dw	7Ah,9
	dw	a,b,c
	dd	d
	dw	p1,t1x,t1z
	dw	p2,t2x,t2z
	dw	p3,t3x,t3z
	dw	p4,t4x,t4z
	dw	p5,t5x,t5z
	dw	p6,t6x,t6z
	dw	p7,t7x,t7z
	dw	p8,t8x,t8z
	dw	p9,t9x,t9z
	endm

GFACET10_TMAP	macro	a,b,c,d,p1,t1x,t1z,p2,t2x,t2z,p3,t3x,t3z,p4,t4x,t4z,p5,t5x,t5z,p6,t6x,t6z,p7,t7x,t7z,p8,t8x,t8z,p9,t9x,t9z,p10,t10x,t10z
	dw	7Ah,10
	dw	a,b,c
	dd	d
	dw	p1,t1x,t1z
	dw	p2,t2x,t2z
	dw	p3,t3x,t3z
	dw	p4,t4x,t4z
	dw	p5,t5x,t5z
	dw	p6,t6x,t6z
	dw	p7,t7x,t7z
	dw	p8,t8x,t8z
	dw	p9,t9x,t9z
	dw	p10,t10x,t10z
	endm

GFACET11_TMAP	macro	a,b,c,d,p1,t1x,t1z,p2,t2x,t2z,p3,t3x,t3z,p4,t4x,t4z,p5,t5x,t5z,p6,t6x,t6z,p7,t7x,t7z,p8,t8x,t8z,p9,t9x,t9z,p10,t10x,t10z,p11,t11x,t11z
	dw	7Ah,11
	dw	a,b,c
	dd	d
	dw	p1,t1x,t1z
	dw	p2,t2x,t2z
	dw	p3,t3x,t3z
	dw	p4,t4x,t4z
	dw	p5,t5x,t5z
	dw	p6,t6x,t6z
	dw	p7,t7x,t7z
	dw	p8,t8x,t8z
	dw	p9,t9x,t9z
	dw	p10,t10x,t10z
	dw	p11,t11x,t11z
	endm

GFACET12_TMAP	macro	a,b,c,d,p1,t1x,t1z,p2,t2x,t2z,p3,t3x,t3z,p4,t4x,t4z,p5,t5x,t5z,p6,t6x,t6z,p7,t7x,t7z,p8,t8x,t8z,p9,t9x,t9z,p10,t10x,t10z,p11,t11x,t11z,p12,t12x,t12z
	dw	7Ah,12
	dw	a,b,c
	dd	d
	dw	p1,t1x,t1z
	dw	p2,t2x,t2z
	dw	p3,t3x,t3z
	dw	p4,t4x,t4z
	dw	p5,t5x,t5z
	dw	p6,t6x,t6z
	dw	p7,t7x,t7z
	dw	p8,t8x,t8z
	dw	p9,t9x,t9z
	dw	p10,t10x,t10z
	dw	p11,t11x,t11z
	dw	p12,t12x,t12z
	endm

GFACET13_TMAP	macro	a,b,c,d,p1,t1x,t1z,p2,t2x,t2z,p3,t3x,t3z,p4,t4x,t4z,p5,t5x,t5z,p6,t6x,t6z,p7,t7x,t7z,p8,t8x,t8z,p9,t9x,t9z,p10,t10x,t10z,p11,t11x,t11z,p12,t12x,t12z,p13,t13x,t13z
	dw	7Ah,13
	dw	a,b,c
	dd	d
	dw	p1,t1x,t1z
	dw	p2,t2x,t2z
	dw	p3,t3x,t3z
	dw	p4,t4x,t4z
	dw	p5,t5x,t5z
	dw	p6,t6x,t6z
	dw	p7,t7x,t7z
	dw	p8,t8x,t8z
	dw	p9,t9x,t9z
	dw	p10,t10x,t10z
	dw	p11,t11x,t11z
	dw	p12,t12x,t12z
	dw	p13,t13x,t13z
	endm

GFACET14_TMAP	macro	a,b,c,d,p1,t1x,t1z,p2,t2x,t2z,p3,t3x,t3z,p4,t4x,t4z,p5,t5x,t5z,p6,t6x,t6z,p7,t7x,t7z,p8,t8x,t8z,p9,t9x,t9z,p10,t10x,t10z,p11,t11x,t11z,p12,t12x,t12z,p13,t13x,t13z,p14,t14x,t14z
	dw	7Ah,14
	dw	a,b,c
	dd	d
	dw	p1,t1x,t1z
	dw	p2,t2x,t2z
	dw	p3,t3x,t3z
	dw	p4,t4x,t4z
	dw	p5,t5x,t5z
	dw	p6,t6x,t6z
	dw	p7,t7x,t7z
	dw	p8,t8x,t8z
	dw	p9,t9x,t9z
	dw	p10,t10x,t10z
	dw	p11,t11x,t11z
	dw	p12,t12x,t12z
	dw	p13,t13x,t13z
	dw	p14,t14x,t14z
	endm

GFACETN_TMAP	macro	a,b,c,d,p1,t1x,t1z,p2,t2x,t2z,p3,t3x,t3z,p4,t4x,t4z,p5,t5x,t5z,p6,t6x,t6z,p7,t7x,t7z,p8,t8x,t8z,p9,t9x,t9z,p10,t10x,t10z,p11,t11x,t11z,p12,t12x,t12z,p13,t13x,t13z,p14,t14x,t14z
	local	lb1,lb2
	dw	7Ah
	dw	[(lb2-lb1)/6]
	dw	a,b,c
	dd	d
lb1	dw	p1,t1x,t1z
	dw	p2,t2x,t2z
	dw	p3,t3x,t3z
	ifnb	<p4>
	dw	p4,t4x,t4z
	endif
	ifnb	<p5>
	dw	p5,t5x,t5z
	endif
	ifnb	<p6>
	dw	p6,t6x,t6z
	endif
	ifnb	<p7>
	dw	p7,t7x,t7z
	endif
	ifnb	<p8>
	dw	p8,t8x,t8z
	endif
	ifnb	<p9>
	dw	p9,t9x,t9z
	endif
	ifnb	<p10>
	dw	p10,t10x,t10z
	endif
	ifnb	<p11>
	dw	p11,t11x,t11z
	endif
	ifnb	<p12>
	dw	p12,t12x,t12z
	endif
	ifnb	<p13>
	dw	p13,t13x,t13z
	endif
	ifnb	<p14>
	dw	p14,t14x,t14z
	endif
lb2	label word
	endm



GFACE4_TMAP	macro	px,py,pz,nx,ny,nz,p1,t1x,t1z,p2,t2x,t2z,p3,t3x,t3z,p4,t4x,t4z
	dw	7bh,4
	dw	px,py,pz,nx,ny,nz
	dw	p1,t1x,t1z
	dw	p2,t2x,t2z
	dw	p3,t3x,t3z
	dw	p4,t4x,t4z
	endm


POLYLINE_FACET	macro	a,b,c,d,p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15,p16,p17,p18,p19,p20,p21,p22,p23,p24,p25,p26,p27,p28,p29,p30,p31,p32
	local	lb1,lb2
	dw	07ch
	dw	[(lb2-lb1)/2]
	dw	a,b,c
	dd	d
lb1	dw	p1,p2,p3
	ifnb	<p4>
	dw	p4
	endif
	ifnb	<p5>
	dw	p5
	endif
	ifnb	<p6>
	dw	p6
	endif
	ifnb	<p7>
	dw	p7
	endif
	ifnb	<p8>
	dw	p8
	endif
	ifnb	<p9>
	dw	p9
	endif
	ifnb	<p10>
	dw	p10
	endif
	ifnb	<p11>
	dw	p11
	endif
	ifnb	<p12>
	dw	p12
	endif
	ifnb	<p13>
	dw	p13
	endif
	ifnb	<p14>
	dw	p14
	endif
	ifnb	<p15>
	dw	p15
	endif
	ifnb	<p16>
	dw	p16
	endif
	ifnb	<p17>
	dw	p17
	endif
	ifnb	<p18>
	dw	p18
	endif
	ifnb	<p19>
	dw	p19
	endif
	ifnb	<p20>
	dw	p20
	endif
	ifnb	<p21>
	dw	p21
	endif
	ifnb	<p22>
	dw	p22
	endif
	ifnb	<p23>
	dw	p23
	endif
	ifnb	<p24>
	dw	p24
	endif
	ifnb	<p25>
	dw	p25
	endif
	ifnb	<p26>
	dw	p26
	endif
	ifnb	<p27>
	dw	p27
	endif
	ifnb	<p28>
	dw	p28
	endif
	ifnb	<p29>
	dw	p29
	endif
	ifnb	<p30>
	dw	p30
	endif
	ifnb	<p31>
	dw	p31
	endif
	ifnb	<p32>
	dw	p32
	endif
lb2	label word
	endm

PERSPECTIVE	macro
	dw	07dh
	endm

SETWRD_LOW64K	macro	v,n
	dw	7eh,v,n
	endm

CITY	macro
	dw	07fh
	endm

RESPNT	macro	n
	dw	080h,n
	endm

ANTI_ALIAS	macro	parm
	dw	081h,parm
	endm

SHADOW_POSITION	macro	lat,latf,lon,lonf,alt,altf
	dw	082h
	dw	latf
	dd	lat
	dw	lonf
	dd	lon
	dw	altf
	dd	alt
	endm

RESCALE	macro	dest,signal,size,factor
	local	start
start  label word
	dw	083h
	dw	(offset dest)-(offset start)
	dw	signal
	dw	size
	dd	factor
	ERRS16	(offset dest)-(offset start)
	endm

SURFACE_NORMAL	macro	nx,ny,nz
	dw	084h
	dw	nx,ny,nz
	endm

NIGHT_COLOR_RANGE	macro	n
	dw	087h,n
	endm

; obsolete w/version 6.x
;FILE_MARKER	macro	fileno
;	dw	088h,fileno
;	endm

FILE_MARKER_32	macro	fileno
	dw	08Dh
	dd	fileno
	endm

VFILE_MARKER	macro	vfileno
	dw	08Eh, vfileno
	endm


CAT_MESH	equ	4
CAT_POLY	equ	8
CAT_RIVER	equ	12
CAT_ROAD	equ	16
CAT_LINE	equ	20
CAT_RUNWAY	equ	24
CAT_MOUNTAIN	equ	28
CAT_SHADOWS	equ	60


SURFACE_CONCRETE	equ	0
SURFACE_GRASS		equ	1
SURFACE_WATER		equ	2

; Scale factors in ii.ff units per meters, S_16 = 1 unit/meter

S_9	equ	8388608
S_10	equ	4194304
S_11	equ	2097152
S_12	equ	1048576
S_13	equ	524288
S_14	equ	262144
S_15	equ	131072
S_16	equ	65536
S_17	equ	32767
S_18	equ	16384
S_19	equ	8192
S_20	equ	4096
S_21	equ	2048
S_22	equ	1024
S_23	equ	512
S_24	equ	256



PVICALL	macro	dest,xvar,yvar,zvar,pp,pv,bb,bv,hh,hv
	local	start
	movwrd	start+4,xvar
	movwrd	start+6,yvar
	movwrd	start+8,zvar
start  label word
	dw	046h
	dw	(offset dest)-(offset start)
	dw	0,0,0
	dw	pp,pv,bb,bv,hh,hv
	ERRS16	(offset dest)-(offset start)
	endm

GENERIC_FUEL_BOX	macro
	local	object_end

	LCOLOR	C_YELLOW
	SET_BRIGHTNESS 07FFFh

	SPNT	-128,0,-188
	CPNT	-128,0,152
	CPNT	 176,0,152
	SPNT	 122,0,-12
	CPNT	-128,0,-12

; refueling ramp
	SPNT	-261,0,-261
	CPNT	 249,0,-261
	CPNT	 249,0,257
	CPNT	-261,0,257
	CPNT	-261,0,-261

	IFIN1	object_end,xv,-261,255
	IFIN1	object_end,zv,-261,257

	setwrd	rpfuel,1

object_end  label word
	endm

GENERIC_TOWER	macro
	local	shadow_me,tower_top,tower_base,tower_top1,tower_light,beacon_white,beacon_on,beacon_off

xsize = 5
ysize = 10
tysize = 12
txsize = 6

	SHADOW_CALL	shadow_me
shadow_me  label word

	RESLIST	0,12
	VERTEX	0,0,0
	VERTEX	xsize,0,0
	VERTEX	xsize,0,xsize
	VERTEX	0,0,xsize
	VERTEX	0,ysize,0
	VERTEX	xsize,ysize,0
	VERTEX	xsize,ysize,xsize
	VERTEX	0,ysize,xsize
	VERTEX	(xsize-txsize),tysize,(xsize-txsize)
	VERTEX	txsize,tysize,(xsize-txsize)
	VERTEX	txsize,tysize,txsize
	VERTEX	(xsize-txsize),tysize,txsize

	IFSIDE		0,32767,0,327670, TOWER_BASE, TOWER_TOP

TOWER_TOP  label word
	IFSIDE	0,1,0,tysize,TOWER_TOP1,TOWER_LIGHT

TOWER_BASE  label word
	SCOLOR	c_white
; south wall
	FACET4	0,0,-32767,0,1,0,4,5
; east wall
	FACET4	32767,0,0,163835,2,1,5,6
; north wall
	FACET4	0,0,32767,163835,3,2,6,7
; west wall
	FACET4	-32767,0,0,0,0,3,7,4
; top of the base
	FACET4	0,32767,0,327670,7,6,5,4

	BGL_RETURN


TOWER_TOP1  label word

; inside top
	SCOLOR	c_gray
	FACE4	0,tysize,0,0,-32767,0,8,9,10,11

; lines for glass
	LCOLOR	c_black

	STRRES	4
	CNTRES	8
	STRRES	5
	CNTRES	9
	STRRES	6
	CNTRES	10
	STRRES	7
	CNTRES	11

; outside top
	SCOLOR	c_black
	FACE4	0,tysize,0,0,32767,0,11,10,9,8

	BGL_RETURN

TOWER_LIGHT  label word
	IFMSK	beacon_white,beacnt,3
	LCOLOR	C_BRIGHT_GREEN
	JUMP	beacon_on

BEACON_WHITE  label word
	IFMSK	beacon_off,beacnt,0300h
	LCOLOR	C_BRIGHT_WHITE

BEACON_ON  label word
	PNT	xsize/2,tysize,xsize/2

BEACON_OFF  label word
	BGL_RETURN


	endm


GENERIC_BEACON	macro
	local	beacon_white,beacon_on,beacon_off

	IFMSK	beacon_white,beacnt,3
	LCOLOR	C_BRIGHT_GREEN
	JUMP	beacon_on

BEACON_WHITE  label word
	IFMSK	beacon_off,beacnt,0300h
	LCOLOR	C_BRIGHT_WHITE

BEACON_ON  label word
	PNT	0,0,0

BEACON_OFF  label word
	endm

VAR_BASE_32	macro	abso_base_addr
	dw	89h
	dd	abso_base_addr
	endm

MIPMAP	macro	mipmap_enable
	dw	92h
	dw	mipmap_enable
	endm

SPECULAR	macro	specular_value
		dw	93h
		dw	specular_value
		endm

BGL_TEXT macro	x,y,z,text_handle,text_flags
	dw	091h
	dw	x,y,z,text_handle,text_flags
	endm

CENTERED_TEXT	equ 1

