; Tutorial Example Database 1
; A Wireframe Cube with a Point on Each Face at Meigs Field



 	include asm.inc 	; include this in ALL .asm files!
	include dumper.inc	; we're dumping data from this file
	include	bglmac.inc	
	include	fs6def.inc

.data
dumper_data	DUMPERDATA	{the_data, the_data_size, 'test.bin'}

the_data	equ	$


; DATABASE HEADER ********************************************************
	dw	0001			;00 world set number (not saved to filelist)
					;   0=off 1=fs5 default world
	dd	0004c0000h		;02 N bound Meter units
	dd	000400000h		;06 S bound
	dd	0c4000000h		;10 E bound 32-bit pseudo
	dd	0bf000000h		;14 W bound
	dd	0			;18 VOR_DATA
	dw	0			;22 lowest vor freq  (channel 0-199)
	dw	0			;24 highest vor freq (108.00-117.95)
	dd	0			;26 seeds level 8
	dd	0			;30 seeds level 9
	dd	0			;34 seeds level 10
	dd	0			;38 seeds level 11
	dd	0			;42 seeds level 12
	dd	0			;46 seeds level 13
	dd	0			;50 seeds level 14
	dd	0			;54 seeds level 15
	dd	object_data - the_data	;58 OBJECT_DATA
	dd	0			;62 LIBRARY_DATA
	dd	0			;66 FACILITIES_DATA
	dd	0			;70 ANCHOR POINT DATA
	dd	0			;74 COM RADIO DATA
	dd	0			;78 ADF DATA
	dd	0			;82 DYNAMIC OBJECT PATHS
	dd	0,0			;86 Library id min
	dd	0,0			;94 Library id max
	dd	0			;102 MISC_DATA (ground alt db)
	dd	0			;106 TITLE AND DESCRIPTION DATA
	dd	0			;110
	dd	0			;114 EXCEPTION LIST PTR
	dd	0			;118
	dd	0			;122 (not saved to filelist)
	dw	0			;126 (not saved to filelist)
					;128




; UNIVERSAL ENTITY OPCODES ***************************************************

EOL	macro
        db	0
        endm

LATBAND_REL	macro	latmin,latmax,band_addr
        db	21
        dw	latmin			;;lat min (inclusive) 512M units
        dw	latmax			;;lat max (exclusive)
        dd	(offset band_addr) - (offset rel_base)	;;32-bit rel_base relative ptr
        endm

LARGE_OBJECT_HEADER	macro	latitude,longitude,object_end
	LOCAL	opcode
opcode	db	5
	dd	latitude,longitude
	db	100			;;image power
	dw	(offset object_end) - (offset opcode)
	endm


; OBJECT DATABASE ************************************************************

object_data	label	word
rel_base	= object_data

	LATBAND_REL	8960,9216,OBJ_LIST_0001
	EOL



OBJ_LIST_0001	label word

; Test cube at meigs
	LARGE_OBJECT_HEADER	0046f9e5h,0c1a09a0ah,object_end

	SCALE	object_end,0,0,13768,0046f7abh,0,0c1b17809h,0,180,0

	RESLIST	0,8
	VERTEX	192	,0	,80
	VERTEX	202	,0	,80
	VERTEX	192	,0	,180
	VERTEX	202	,0	,180

	VERTEX	192	,4	,80
	VERTEX	202	,4	,80
	VERTEX	192	,4	,180
	VERTEX	202	,4	,180

	LCOLOR	C_BLACK

	STRRES	0		;cube base
	CNTRES	1
	CNTRES	3
 	CNTRES	2
	CNTRES	0

	STRRES	4		;cube top
	CNTRES	5
	CNTRES	7
	CNTRES	6
	CNTRES	4


	STRRES	0		;cube vertical edges
	CNTRES	4

	STRRES	1		
	CNTRES	5

	STRRES	3
	CNTRES	7

	STRRES	2
	CNTRES	6

; points on cube faces

	LCOLOR	C_BRIGHT_GREEN

	PNT     197,2,180
	PNT     197,2,80

	LCOLOR	C_BRIGHT_RED

	PNT     192,2,130
	PNT     202,2,130
	PNT     197,0,130
	PNT     197,4,130

;	BGL_RETURN

object_end      label	word

	EOL



the_data_size	equ	$ - the_data
	end

