; Tutorial Example Database 3
; A VOR placed at O'Hare airport in Chicago

	include asm.inc 	; include this in ALL .asm files!
	include dumper.inc	; we're dumping data from this file


.data
dumper_data	DUMPERDATA	{the_data, the_data_size, 'test.bin'}

the_data	equ	$


; DATABASE HEADER *************************************************************
	dw	0001			;00 world set number (not saved to filelist)
					;   0=off 1=fs5 default world

	dd	000490000h		;02 N bound Meter units
	dd	0003f0000h		;06 S bound
	dd	0cf000000h		;10 E bound 32-bit pseudodegrees
	dd	0bf000000h		;14 W bound
	dd	VOR_DATA - the_data	;18 VOR_DATA
	dw	52			;22 lowest vor freq  (channel 0-199)
	dw	52			;24 highest vor freq (108.00-117.95)

	dd	0			;26 seeds level 8
	dd	0			;30 seeds level 9
	dd	0			;34 seeds level 10
	dd	0			;38 seeds level 11
	dd	0			;42 seeds level 12
	dd	0			;46 seeds level 13
	dd	0			;50 seeds level 14
	dd	0			;54 seeds level 15
	dd	0			;58 OBJECT_DATA
	dd	0			;62 LIBRARY_DATA
	dd	0			;66 FACILITIES_DATA
	dd	0			;70 ANCHOR POINT DATA
	dd	0			;74 COM RADIO DATA
	dd	0			;78 ADF DATA
	dd	0			;82 DYNAMIC OBJECT PATHS
	dd	0,0			;86 Library id min
	dd	0,0			;94 Library id max
	dd	0			;102 MISC_DATA (ground alt db)
	dd	0			;106 TITLE AND DESCRIPTION DATA
	dd	0			;110
	dd	0			;114 EXCEPTION LIST PTR
	dd	0			;118
	dd	0			;122 (not saved to filelist)
	dw	0			;126 (not saved to filelist)
					;128


; UNIVERSAL ENTITY OPCODES ***********************************************
EOL	macro
	db      0
	endm

LATBAND_REL     macro	latmin,latmax,band_addr
	db      21
	dw      latmin			;;lat min (inclusive) 512M units
	dw      latmax			;;lat max (exclusive)
	dd      (offset band_addr) - (offset rel_base)	;;32-bit rel_base relative ptr
	endm

BAND_SET_DEFINE	macro	bandset_addr
	db      1
	dd      bandset_addr-rel_base
	endm

VOR_ENTITY macro lathi,latlo,lonhi,lonlo,alt,code,ident5,name24
	db	4
	db	80		;;VOR ENTITY
				;;  range = in 2048M units (approx 2 KM)
	dw	0123		;;magvar
	db	code		;;code
				;; bit0 = DME
				;; bit1 = TACAN (note: if TACAN handles DME too, set DME bit also)
				;; bit2 = Voice Available
				;; bit3 = Nav Signal Unavailable (DME only)
				;; bit4 = spare
				;; bit5 = spare
				;; bit6 = 0 =Glideslope Available
				;; bit7 = 0 = VOR  1=Localizer (always 0)
	dw	latlo		;;N 41.85611511  (2M units)
	db	lathi
	dw	lonlo		;;W 87.71153846	(24-bit pseudo)
	db	lonhi
	dw	alt		;;altit M
	dw	0		;;localizer direction (16-bit pseudo)
	db	ident5		;;5-character identifier (ascii)
	db	name24		;;24-byte name of navaid (ascii)
	endm


; VOR DATABASE ****************************************************************

VOR_DATA	label	word
rel_base	= VOR_DATA
	BAND_SET_DEFINE	VOR_11060	;vor for freq 110.60 channel 52


VOR_11060	label	word
	LATBAND_REL	9113-200,9113+200,v1060_1	;ohare latitude +-200
	EOL

v1060_1	label	word
	VOR_ENTITY 	23h,098afh,0c1h,06000h,204,0001h,'OHAR1','ohare test vor          '
	EOL


the_data_size	equ	$ - the_data
	end

