// SDK.Attitude.c
// Copyright (c) 1997 Microsoft Corporation.  All rights reserved.
//
// Copied from Extra 300 attitude gauge
//

#include "gauges.h"
#include "SDK.Attitude.h"

//	Set up import and export tables and gauge header
char		gauge_name[]		= "SDK.Attitude\0";
extern PELEMENT_HEADER		list;
MODULE_SETUP( GAUGE_HEADER_VERSION, 89, gauge_name, &list );


FAILURE_RECORD	fail[] =
{
	{FAIL_GAUGE_ATTITUDE, FAIL_ACTION_NONE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

MAKE_SPRITE(	sprite_outer,
				BMP_CARD2,
				NULL,
				(PFAILURE_RECORD)fail,
				IMAGE_USE_TRANSPARENCY,
				0,
				{16, 13},
				{137,134},
				1.05, 1.05,
				{48,48},

				MODULE_VAR_NONE, NULL, 0,
				MODULE_VAR_NONE, NULL, 0,
				ATTITUDE_INDICATOR_BANK_DEGREES, NULL, -1 )

PELEMENT_HEADER		plist2[] =
{
	&sprite_outer.header,
	NULL
};

MODULE_VAR_CB	pitch_limit;
#define	PITCH_LIMIT		43.0		// stop at 43 degrees

MAKE_SPRITE(	sprite_inner,
				BMP_CARD1,
				&plist2,
				fail,
				IMAGE_USE_TRANSPARENCY,
				0,
				{55,  53},
				{137, 134},
				0.55, 0.55,
				{76,  76},

				MODULE_VAR_NONE, NULL, 0,
				ATTITUDE_INDICATOR_PITCH_DEGREES, pitch_limit, 2.0,
				ATTITUDE_INDICATOR_BANK_DEGREES, NULL, -1 )

PELEMENT_HEADER		plist1[] =
{
	&sprite_inner.header,
	NULL
};

MAKE_STATIC(	background,
				BMP_BACKGROUND,
				&plist1,
				fail,
				IMAGE_USE_TRANSPARENCY,
				0,
				{0,0} )

PELEMENT_HEADER		list	= &background.header;


MOUSE_BEGIN( mouse_rect, HELPID_EXTR_ATTITUDE_INDICATOR, 0, 0 )
MOUSE_END


//---------------------------------------------------------------------------
FLOAT64	FSAPI	pitch_limit( PMODULE_VAR	var )
{
	if( var->var_value.n > PITCH_LIMIT )
		return PITCH_LIMIT;
	else if( var->var_value.n < -PITCH_LIMIT )
		return -PITCH_LIMIT;
	else
		return var->var_value.n;
}


//---------------------------------------------------------------------------
void FSAPI		install_routine( HINSTANCE resource_file_handle )
{
	element_list_install( list, resource_file_handle );
	mouse_list_install( mouse_rect, &gauge_header, &background.image_data.final->dim );
	mouse_list_register( mouse_rect, &gauge_header );
}


//---------------------------------------------------------------------------
void FSAPI		initialize_routine()
{
	element_list_initialize( list );
}


//---------------------------------------------------------------------------
void FSAPI		update_routine()
{
	element_list_update(list);
}

//---------------------------------------------------------------------------
void FSAPI		generate_routine( GENERATE_PHASE phase )
{
	element_list_generate( list, phase );
}


//---------------------------------------------------------------------------
void FSAPI		draw_routine()
{
	element_list_plot( list );
}


//---------------------------------------------------------------------------
void FSAPI		kill_routine()
{
	mouse_list_unregister( mouse_rect, &gauge_header );
	element_list_kill( list );
}

