// SDK.Temperature.c
// Copyright (c) 1997 Microsoft Corporation.  All rights reserved.
//
// Copied from Cessna temperature gauge
//

#include	<windows.h>
#include	"gauges.h"
#include	"SDK.Temperature.h"

//	Set up import and export tables and gauge header
char		gauge_name[]		= "SDK.Temperature\0";
extern PELEMENT_HEADER		list;
MODULE_SETUP( GAUGE_HEADER_VERSION, 40, gauge_name, &list );


#define GAUGE_CHARSET						DEFAULT_CHARSET
#define GAUGE_FONT_DEFAULT					"Courier New"
#define GAUGE_WEIGHT_DEFAULT				FW_NORMAL


FN_FLOAT64	update_string_temp;

FAILURE_RECORD	elec_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL, FAIL_ACTION_NO_DRAW},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

MAKE_STRING(	temp,
				NULL,
				elec_fail,
				IMAGE_USE_ERASE | IMAGE_USE_BRIGHT,
				0,
				{28, 9},
				{60, 29},
				3,
				TOTAL_AIR_TEMP, NULL,
				DISPLAY_UNITS, NULL,
				MODULE_VAR_NONE, NULL,
				update_string_temp,
				RGB(255,0,0),
				RGB(0,0,0),
				RGB(92,92,92),
				GAUGE_FONT_DEFAULT,
				GAUGE_WEIGHT_DEFAULT,
				GAUGE_CHARSET,
				NULL )


MODULE_VAR_CB	icon_cb;

MAKE_ICON(	cf,
			BMP_F,
			NULL,
			elec_fail,
			0,
			0,
			{99, 9},
			DISPLAY_UNITS, icon_cb,
			ICON_SWITCH_TYPE_SET_CUR_ICON,
			2,
			0,
			0 )

PELEMENT_HEADER		plist[] =
{
	&temp.header,
	&cf.header,
	NULL
};

MAKE_STATIC(	background,
				BMP_BACKGROUND,
				&plist,
				NULL,
				IMAGE_USE_TRANSPARENCY,
				0,
				{0,0} )

PELEMENT_HEADER		list	= &background.header;


MOUSE_BEGIN( mouse_rect, HELPID_CESS_TEMPERATURE, 0, 0 )
MOUSE_END


//---------------------------------------------------------------------------
FLOAT64 FSAPI	icon_cb( PMODULE_VAR var )
{
	if( var->var_value.n == ENGLISH_UNITS )
		return 0;
	else
		return 1;
}

FLOAT64 FSAPI	update_string_temp( FLOAT64 val )
{
	val *= 256;

	if( temp.source_var[1].var_value.n == ENGLISH_UNITS )
		val = val*9/5 +32;

	// limit var
	if ( val > 999 )
		val = 999.0;
	else if( val < -99 )
		val = -99;

	wsprintf(temp.string, "%3d", (UINT32)val);

	return val;
}

//---------------------------------------------------------------------------
void FSAPI	install_routine( HINSTANCE resource_file_handle )
{
	element_list_install( list, resource_file_handle );
	mouse_list_install( mouse_rect, &gauge_header, &background.image_data.final->dim );
	mouse_list_register( mouse_rect, &gauge_header );
}


//---------------------------------------------------------------------------
void FSAPI	initialize_routine()
{
	element_list_initialize( list );
}


//---------------------------------------------------------------------------
void FSAPI	update_routine()
{
	element_list_update( list );
}


//---------------------------------------------------------------------------
void FSAPI	generate_routine( GENERATE_PHASE phase )
{
	element_list_generate( list, phase );
}


//---------------------------------------------------------------------------
void FSAPI	draw_routine()
{
	element_list_plot( list );
}


//---------------------------------------------------------------------------
void FSAPI	kill_routine()
{
	mouse_list_unregister( mouse_rect, &gauge_header );
	element_list_kill( list );
}

